<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
require_once "../../maincore.php";
require_once INFUSIONS."theme_database/theme_database_inc.php";
if (file_exists(THEME_DB_DIR."locale/".$settings['locale'].".php")) {
	include THEME_DB_DIR."locale/".$settings['locale'].".php";
} else {
	include THEME_DB_DIR."locale/English.php";
}
require_once THEMES."templates/header.php";
require_once INCLUDES."ratings_include.php";
require_once INCLUDES."comments_include.php";

$theme_items_per_page = !empty($themedb_settings["items_per_page"]) ? $themedb_settings["items_per_page"] : 300;
$theme_rowstart = (!empty($_GET["rowstart"]) AND is_numeric($_GET["rowstart"]))? $_GET["rowstart"] : 0;
$cat_ids = get_cat_ids();
$link = FUSION_REQUEST;
if (stristr(FUSION_REQUEST, "rowstart")){
    if(stristr(FUSION_REQUEST, "?rowstart")){
        $link = preg_replace("#\?rowstart=[\d]+&#i", "?", FUSION_REQUEST);
    }else{
        $link = preg_replace("#&rowstart=\d*#i", "", FUSION_REQUEST);
    }
}
if(stristr($link, "?"))
    $link .="&amp;";
else
    $link .= "?";
if(empty($_GET['view']) OR $_GET['view'] == "categorized"){
    opentable($locale['themedb_name']);
    //admin_options("main");
    if (iMEMBER) {
    echo "<div style='margin-bottom:10px;'>".$locale['themedb_intro_member']."</div>";
    } else {
    echo "<div style='margin-bottom:10px;'>".$locale['themedb_intro']."</div>";
    }
    display_options();
    open_cat_table();
    $result = select_themes();
    $count_data = dbarray(dbquery("Select FOUND_ROWS() as count"));
    $count = $count_data["count"];
    if($count > 0){
        $cat_id = 0;
        while($theme = dbarray($result)){
            if($theme["cat_id"] != $cat_id){
                cat_row($theme["cat_id"]);
                $cat_id = $theme["cat_id"];
            }
            theme_row($theme);
        }
    }else{
        no_themes();
    }
    close_cat_table();
    if($count > $theme_items_per_page){
        echo "<div align='center'  style='margin-top:20px;'>".makepagenav($theme_rowstart,$theme_items_per_page,$count,5,$link)."</div>";
    }
//    top_themes();
//    if($themedb_settings['statistics'] == 1)
//        stats();
    closetable();
    
}elseif(is_numeric($_GET['view']) AND in_array($_GET['view'], $cat_ids)){
	quicknav("cat", $_GET['view']);
    opentable($locale['themedb_name']);
    display_options();
    open_cat_table();
    $result = select_themes($_GET['view']);
    $count_data = dbarray(dbquery("Select FOUND_ROWS() as count"));
    $count = $count_data["count"];
    if($count > 0){
        cat_row($_GET['view']);
        while($theme = dbarray($result)){
            theme_row($theme);
        }
    }else{
        no_themes();
    }
    close_cat_table();
    if($count > $theme_items_per_page)
        echo "<div align='center'  style='margin-top:20px;'>".makepagenav($theme_rowstart,$theme_items_per_page,$count,5,$link)."</div>";
//    top_themes($_GET['view']);
//    stats($_GET['view']);
    closetable();

}elseif($_GET['view'] == "uncategorized"){
    opentable($locale['themedb_name']);
    quicknav("cat");
    display_options();
    open_cat_table();
    $result = select_themes();
    $count_data = dbarray(dbquery("Select FOUND_ROWS() as count"));
    $count = $count_data["count"];
    if($count > 0){
        cat_row();
        while($theme = dbarray($result)){
            theme_row($theme);
        }
    }else{
        no_themes();
    }
    close_cat_table();
    if($count > $theme_items_per_page)
        echo "<div align='center'  style='margin-top:20px;'>".makepagenav($theme_rowstart,$theme_items_per_page,$count,5,$link)."</div>";
//    top_themes();
//    stats();
    closetable();
    
}elseif($_GET['view'] == "slideshow"){
    opentable($locale['themedb_name']);
    quicknav("cat");
    display_options();
    open_cat_table();
    $result = select_themes();
    $count_data = dbarray(dbquery("Select FOUND_ROWS() as count"));
    $count = $count_data["count"];
    if($count > 0){
        cat_row("",$locale['themedb_slideshow'], "slideshow");
        while($theme = dbarray($result)){
            theme_row($theme,"slideshow");
        }
    }else{
        no_themes();
    }
    close_cat_table();
    if($count > $theme_items_per_page)
        echo "<div align='center'  style='margin-top:20px;'>".makepagenav($theme_rowstart,$theme_items_per_page,$count,5,$link)."</div>";
    closetable();
    
}elseif($_GET['view'] == "theme" AND is_numeric($_GET["theme_id"])){
    $result = dbquery("SELECT * FROM ".DB_PREFIX."themedb WHERE id=".$_GET["theme_id"]);
    if(dbrows($result) == 1){
        $data = dbarray($result);
        quicknav("theme", $data['cat_id'], $data['id'], (empty($data['author_name']) ? $data['author_id'] : $data['author_name']));
        //admin_options("theme");
        show_theme($data);
    }else
        display_message($locale['themedb_no_theme_of_id_title'],$locale['themedb_no_theme_of_id']);
        
}elseif($_GET['view'] == "edit" AND is_numeric($_GET["theme_id"])){
    require_once THEME_DB_DIR."theme_submission_inc.php";
    $theme_result = dbquery("SELECT * FROM ".DB_PREFIX."themedb WHERE id='".$_GET["theme_id"]."'");
    if(dbrows($theme_result) == 1){
        $theme_data = dbarray($theme_result);
        opentable($locale['themedb_name']." | ".$locale['themedb_edit'].": ".$theme_data['name']);
        if($theme_data['author_id'] == $userdata['user_id'] OR iADMIN){
            //$mode = !iADMIN ? "admin" : "user";
            $mode = !iADMIN && checkrights("TDB") ? "admin" : "user";
            if(!empty($_POST['submit_theme'])){
                if(check_submission("edit", $_GET["theme_id"], $mode)){
                    if(write_submission($mode, "edit", $_GET["theme_id"]))
                    //display_message($locale['themedb_msg_success'], $locale['themedb_submissions']['theme_update_ok']."<br />\n<form style='display:inline;' action='".FUSION_SELF.$aidlink."' method='post'><input type='submit' class='button' value='OK' /></form>");
                      display_message($locale['themedb_msg_success'], $locale['themedb_submissions']['theme_update_ok']."<br />\n<form style='display:inline;' action='".FUSION_SELF."' method='post'><input type='submit' class='button' value='OK' /></form>");
                }else{
                    theme_form($mode, "edit", $theme_data);
                }
            }else{
                theme_form($mode, "edit", $theme_data);
            }
        }else{
            display_message($locale['themedb_not_author_title'],$locale['themedb_not_author']);
        }
        closetable();
    }else{
        opentable($locale['themedb_name']." | ".$locale['themedb_edit']);
        display_message($locale['themedb_no_theme_of_id_title'],$locale['themedb_no_theme_of_id']);
        closetable();
    }
}elseif($_GET['view'] == "awards"){
	opentable("Awards");
	echo show_awards();
	closetable();
}

require_once THEMES."templates/footer.php";
?>