<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
if (!defined("IN_FUSION") || !checkrights("I")) { header("Location: ../../index.php"); exit; }

include INFUSIONS."theme_database/infusion_db.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."theme_database/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."theme_database/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."theme_database/locale/English.php";
}

// Infusion general information
$inf_title = $locale['themedb_name'];
$inf_description = $locale['themedb_desc'];
$inf_version = "1.2.2";
$inf_developer = "Matonor";
$inf_email = "matonor@gmail.com";
$inf_weburl = "http://themes.php-fusion.co.uk";

$inf_folder = "theme_database";

// Delete any items not required below.
$inf_newtable[1] = THEME_DB." (
	id smallint(6) NOT NULL auto_increment,
	name varchar(255) NOT NULL default '',
	theme_folder varchar(100) NOT NULL default '',
	cat_id smallint(6) NOT NULL default '0',
	submission_time int(32) NOT NULL default '0',
	last_change_time int(32) NOT NULL default '0',
	author_id int(11) NOT NULL default '0',
	author_name varchar(60) NOT NULL default '',
	author_web varchar(255) NOT NULL default '',
	author_mail varchar(150) NOT NULL default '',
	submitter_id int(11) NOT NULL default '0',
	`desc` text NOT NULL,
	copyright text NOT NULL,
	graphic_amnt tinyint(4) NOT NULL default '0',
	valid_css tinyint(4) NOT NULL default '0',
	valid_html tinyint(4) NOT NULL default '0',
	brightness tinyint(4) NOT NULL default '0',
	color varchar(150) NOT NULL default '',
	blank_button tinyint(4) NOT NULL default '0',
	blank_logo tinyint(4) NOT NULL default '0',
	size varchar(20) NOT NULL default '',
	width_type tinyint(4) NOT NULL default '0',
	width varchar(10) NOT NULL default '',
	version varchar(20) NOT NULL default '',
	fusion_version varchar(40) NOT NULL default '',
	approved tinyint(4) NOT NULL default '0',
	recommended tinyint(4) NOT NULL default '0',
	download_count int(11) NOT NULL default '0',
	view_count int(11) NOT NULL default '0',
	screenshot_ext varchar(4) NOT NULL default '',
	PRIMARY KEY  (id)
) TYPE=MyISAM;";

$inf_newtable[2] = THEME_DB_CATS." (
	cat_id int(11) NOT NULL auto_increment,
	cat_parent int(11) NOT NULL default '0',
	cat_name varchar(255) NOT NULL default '',
	cat_icon varchar(255) NOT NULL default '',
	cat_desc text NOT NULL,
	PRIMARY KEY  (cat_id)
) TYPE=MyISAM;";

$inf_newtable[3] = THEME_DB_SETTINGS." (
	fusion_versions text NOT NULL,
	items_per_page tinyint(3) NOT NULL default '25',
	max_file_size int(11) NOT NULL default '512000',
	max_screen_size int(11) NOT NULL default '153600',
	screen_w smallint(6) NOT NULL default '800',
	screen_h smallint(6) NOT NULL default '600',
	max_thumb_size int(11) NOT NULL default '25600',
	thumb_w smallint(6) NOT NULL default '200',
	thumb_h smallint(6) NOT NULL default '150',
	statistics tinyint(1) NOT NULL default '1',
	submissions tinyint(1) NOT NULL default '1'
) TYPE=MyISAM;";

$inf_newtable[4] = THEME_DB_AWARDS." (
	award_id int(11) NOT NULL auto_increment,
	award_name varchar(255) NOT NULL default '',
	award_image varchar(255) NOT NULL default 'awards/default.png',
	award_desc text NOT NULL,
	award_req text NOT NULL,
	PRIMARY KEY  (award_id)
) TYPE=MyISAM;";

//Set DATA

$inf_insertdbrow[1] = THEME_DB_SETTINGS." SET
	fusion_versions ='6.01.x|6.00.x|<6.00x|7.0',
	items_per_page = 25,
	max_file_size = 512000,
	max_screen_size = 153600,
	screen_w = 800,
	screen_h = 600,
	max_thumb_size = 25600,
	thumb_w = 200,
	thumb_h = 150,
	statistics = 1,
	submissions = 1";

//$inf_droptable[1] = DB_INFUSION_TABLE;

//$inf_altertable[1] = DB_INFUSION_TABLE." ADD etc";

$inf_deldbrow[1] = THEME_DB_SETTINGS;

$inf_adminpanel[1] = array(
	"title" => "Theme DB",
	"image" => "image.gif",
	"panel" => "theme_database_admin.php",
	"rights" => "TDB"
);

$inf_sitelink[1] = array(
	"title" => "Theme Database",
	"url" => "index.php",
	"visibility" => "0"
);

/*

$inf_insertdbrow_[1] = "themedb_settings VALUES ('6.01.x|6.00.x|<6.00x', 5, 512000, 153600, 800, 600, 25600, 200, 150, 1, 1);";

$inf_droptable_[1] = "table_name";

$inf_altertable_[1] = "table_name ADD etc";

$inf_deldbrow_[1] = "other_table";
*/
?>
