<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";
require_once INFUSIONS."theme_database/theme_database_inc.php";
require_once THEME_DB_DIR."theme_submission_inc.php";

if (!checkrights("TDB") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../index.php"); }

if (file_exists(THEME_DB_DIR."locale/".$settings['locale'].".php")) {
	include THEME_DB_DIR."locale/".$settings['locale'].".php";
} else {
	include THEME_DB_DIR."locale/English.php";
}
$rowstart = 0;

$items_per_page = 100;

$action = isset($_GET['action']) && !empty($_GET['action']) ? $_GET['action'] : "";

$show_settings = true;

opentable("Theme Database Admin Panel");
    ////Actions
    //Cats
    if(isset($_POST['new_cat_submit']) AND !empty($_POST['cat_name'])){
          dbquery("INSERT INTO ".THEME_DB_CATS." SET cat_name='".addslash($_POST['cat_name'])."', cat_desc='".addslash($_POST['cat_desc'])."'");
          display_message("Category Created!", "Category was successfully created.<br />\n<form style='display:inline;' action='".FUSION_SELF.$aidlink."' method='post'><input type='submit' class='button' value='OK' /></form>");
    }elseif(isset($_POST['new_award_submit']) AND !empty($_POST['award_name'])){
          dbquery("INSERT INTO ".THEME_DB_AWARDS." SET award_name='".addslash($_POST['award_name'])."', award_image='".addslash($_POST['award_image'])."', award_desc='".addslash($_POST['award_desc'])."', award_req='".addslash($_POST['award_req'])."'");
          display_message("Award Added!", "The Award was successfully added.<br />\n<form style='display:inline;' action='".FUSION_SELF.$aidlink."' method='post'><input type='submit' class='button' value='OK' /></form>");
    }
    
    
    if((!empty($_GET['cat_id']) AND is_numeric($_GET['cat_id'])) OR (!empty($_GET['theme_id']) AND is_numeric($_GET['theme_id']) ) OR (!empty($_GET['award_id']) AND is_numeric($_GET['award_id'])) ){
        switch($action){
            case "delete_cat":
                dbquery("DELETE FROM ".THEME_DB_CATS." WHERE cat_id=".$_GET['cat_id']);
                display_message("Category Deleted!", "Category was successfully deleted.<br />\n<form style='display:inline;' action='".FUSION_SELF.$aidlink."' method='post'><input type='submit' class='button' value='OK' /></form>");
            break;
            case "edit_cat":
                if(isset($_POST['edit_cat_submit'])){
                    dbquery("UPDATE ".THEME_DB_CATS." SET cat_name='".addslash($_POST['cat_name'])."', cat_desc='".addslash($_POST['cat_desc'])."' WHERE cat_id=".$_GET['cat_id']);
                    display_message("Category Updated!", "Category was successfully updated!");
                }
            break;
            //Themes
            case "approve_theme":
                dbquery("UPDATE ".THEME_DB." SET approved = 1 WHERE id = ".$_GET['theme_id']);
                approve_theme($_GET['theme_id']);
            break;
            case "reject_theme":
                if(!empty($_POST["reject_reason"])){
                    reject_theme($_GET['theme_id'], $_POST["reject_reason"]);
                }else{
                    display_message("Reject Theme", "Give a reason for the rejection of this theme:
                    <form name='theme_rejection_form' method='post' action='".FUSION_SELF.$aidlink."&amp;action=reject_theme&amp;theme_id=".$_GET['theme_id']."'>
                    <textarea name='reject_reason' class='textbox' style='width:50%; height:50px;'></textarea><br />
                    <input type='submit' value='Reject Theme' class='button' />
                    </form>");
                }
            break;
            case "delete_theme":
                if(is_numeric($_GET['theme_id'])){
                    $theme_data = dbarray(dbquery("SELECT cat_id, name, id, screenshot_ext FROM ".THEME_DB." WHERE id=".$_GET["theme_id"]));
                    $theme_file = THEME_DB_DIR."downloads/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."].zip";
                    $screen_file = THEME_DB_DIR."screenshots/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."].".$data['screenshot_ext'];
                    $thumb_file = THEME_DB_DIR."screenshots/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."]t.".$theme_data['screenshot_ext'];
                    if(unlink($theme_file) AND unlink($screen_file) AND unlink($thumb_file))
                        display_message("Delete Successful", "All Files deleted successfully");
                    else
                        display_message("Delete failed", "Not all Files were deleted successfully");
                    dbquery("DELETE FROM ".THEME_DB." WHERE id=".$_GET["theme_id"]);
                    dbquery("DELETE FROM ".DB_PREFIX."comments WHERE comment_type = 'T' AND comment_item_id=".$_GET["theme_id"]);
                    display_message("Theme deleted!", "Theme was successfully deleted.<br />\n<form style='display:inline;' action='".FUSION_SELF.$aidlink."' method='post'><input type='submit' class='button' value='OK' /></form>");
                    }
            break;
            case "edit_theme":
                if(!empty($_POST['submit_theme'])){
                    if(check_submission("edit", $_GET["theme_id"], "admin")){
                        if(write_submission("admin", "edit", $_GET["theme_id"]))
                            display_message("Theme written!", "Theme was successfully updated.<br />\n<form style='display:inline;' action='".FUSION_SELF.$aidlink."' method='post'><input type='submit' class='button' value='OK' /></form>");
                    }else{
                        $theme_data = dbarray(dbquery("SELECT * FROM ".THEME_DB." WHERE id=".$_GET["theme_id"]));
                        theme_form("admin", "edit", $theme_data);
                    }
                    
                }else{
                    $theme_data = dbarray(dbquery("SELECT * FROM ".THEME_DB." WHERE id=".$_GET["theme_id"]));
                    theme_form("admin", "edit", $theme_data);
                }
            break;
            case "delete_award":
            	dbquery("DELETE FROM ".THEME_DB_AWARDS." WHERE award_id='".$_GET['award_id']."'");
            	display_message("Award Deleted!", "The Award was successfully deleted<br />\n<form style='display:inline;' action='".FUSION_SELF.$aidlink."' method='post'><input type='submit' class='button' value='OK' /></form>");
            break;
            case "edit_award":
            	if(isset($_POST['edit_award_submit'])){
            		dbquery("UPDATE ".THEME_DB_AWARDS." SET award_name='".addslash($_POST['award_name'])."', award_image='".addslash($_POST['award_image'])."', award_desc='".addslash($_POST['award_desc'])."', award_req='".addslash($_POST['award_req'])."'");
            		display_message("Award Updated!", "The Award was successfully updated<br />\n<form style='display:inline;' action='".FUSION_SELF.$aidlink."' method='post'><input type='submit' class='button' value='OK' /></form>");
				}
            break;
        }
    
    }
    //Settings
    if(iSUPERADMIN){
        if(!empty($_POST['submit_settings'])){
            $qry = "UPDATE ".DB_PREFIX."themedb_settings SET
            fusion_versions = '".$_POST['fusion_versions']."',
            items_per_page = ".$_POST['themes_per_page'].",
            max_file_size = ".$_POST['max_file_size'].",
            max_screen_size = ".$_POST['max_screen_size'].",
            screen_w = ".$_POST['screen_w'].",
            screen_h = ".$_POST['screen_h'].",
            max_thumb_size = ".$_POST['max_thumb_size'].",
            thumb_w = ".$_POST['thumb_w'].",
            thumb_h = ".$_POST['thumb_h'].",
            statistics = ".$_POST['statistics'].",
            submissions = ".$_POST['submissions'];
            if(dbquery($qry))
                display_message("Settings update!", "Theme DB Settings successfully updated.<br />\n<form style='display:inline;' action='".FUSION_SELF.$aidlink."' method='post'><input type='submit' class='button' value='OK' /></form>");
        }
    }
    //Actions End
    
    //Themes
    open_cat_table();
    $result = select_themes("", "unapproved");
    cat_row("","Themes awaiting Approval", "admin");
    while($theme = dbarray($result)){
        theme_row($theme, "admin");
    }
    close_cat_table();

    //Categories
    open_cat_table();
    echo "<tr><th colspan='3' class='forum-caption' style='text-align:left;'>Categories</th></tr>
    <tr><th class='tbl1'>Category Name</th><th class='tbl1'>Themes in Category</th><th class='tbl1'>Action</th></tr>";
    $cat_result = dbquery("SELECT cat_name, cat_desc, ".THEME_DB_CATS.".cat_id, count(".DB_PREFIX."themedb.id) as theme_count FROM ".THEME_DB_CATS." LEFT JOIN ".THEME_DB." ON ".THEME_DB_CATS.".cat_id = ".DB_PREFIX."themedb.cat_id GROUP BY ".THEME_DB_CATS.".cat_id");
    while($cat_data = dbarray($cat_result)){
        if($action == "edit_cat" AND $_GET['cat_id'] == $cat_data['cat_id']){
            echo "
            <tr><td class='tbl2' style='font-weight:bold;'>Edit Category:</td>
                <td class='tbl2' colspan='2'>
                    
                    <form style='display:inline;' method='post' action='".FUSION_SELF.$aidlink."&amp;action=edit_cat&amp;cat_id=".$cat_data['cat_id']."'>
                        <label for='cat_name'>Name:</label><input style='vertical-align: middle;' type='text' class='textbox' name='cat_name' value='".stripslash($cat_data['cat_name'])."' />
                        <label for='cat_desc'>Description:</label><textarea style='width:50%;height:25px;vertical-align: middle;' class='textbox' name='cat_desc'>".stripslash($cat_data['cat_desc'])."</textarea>
                        <input class='button' type='submit' name='edit_cat_submit' value='Edit!' />
                    </form>
                </td>
            </tr>";
        }else{
            echo "
            <tr>
                <td class='tbl2'>".$cat_data['cat_name']."</td>
                <td class='tbl2'>".$cat_data['theme_count']."</td>
                <td class='tbl2'>
                    <a href='".FUSION_SELF.$aidlink."&amp;action=edit_cat&amp;cat_id=".$cat_data['cat_id']."'>Edit</a> |
                    <a href='".FUSION_SELF.$aidlink."&amp;action=delete_cat&amp;cat_id=".$cat_data['cat_id']."' onclick='return confirm(\"Really Delete ".$cat_data['cat_name']."\")'>Delete</a>
                </td>
            </tr>";
        }
    }
    if($action != "edit_cat"){
        echo "<tr><td class='tbl2' style='font-weight:bold;'>New Category:</td>
            <td class='tbl2' colspan='2'>
            <form style='display:inline;' method='post' action='".FUSION_SELF.$aidlink."&amp;action=new_cat'>
                <label for='cat_name'>Name:</label><input style='vertical-align: middle;' type='text' class='textbox' name='cat_name' />
                <label for='cat_desc'>Description:</label><textarea style='width:50%;height:25px;vertical-align: middle;' class='textbox' name='cat_desc'></textarea>
                <input class='button' type='submit' name='new_cat_submit' value='Create!' />
            </form>
            </td>
        </tr>";
    }else{
        echo"<tr><td class='tbl2' colspan='3'><a href='".FUSION_SELF.$aidlink."'>New Category</a></td></tr>";
    }
    close_cat_table();
    //Categories End
    
    //Main Settings
    if(iSUPERADMIN && $show_settings){
        echo "<form action='".FUSION_SELF.$aidlink."&amp;change_settings=1' method='post'>";
        open_cat_table();
        echo "
        <tr><th colspan='2' class='forum-caption' style='text-align:left;'>Settings</th></tr>
        <tr>
            <td class='tbl2' style='width:20%;'>Submissions:</td>
            <td class='tbl2'>
                <select class='textbox' name='submissions'>
                    <option value='0' ".($themedb_settings["submissions"] == 0? "selected" : "").">disabled</option>
                    <option value='1' ".($themedb_settings["submissions"] == 1? "selected" : "").">enabled</option>
                </select>
            </td>
        </tr>
        <tr>
            <td class='tbl2'>Statistics:</td>
            <td class='tbl2'>
                <select class='textbox' name='statistics'>
                    <option value='0' ".($themedb_settings["statistics"] == 0? "selected" : "").">disabled</option>
                    <option value='1' ".($themedb_settings["statistics"] == 1? "selected" : "").">enabled</option>
                </select>
                </td>
        </tr>
        <tr>
            <td class='tbl2'>Fusion Versions:</td>
            <td class='tbl2'><textarea name='fusion_versions' class='textbox' style='width:200px;vertical-align:middle;'>".$themedb_settings["fusion_versions"]."</textarea>Devided by \"|\" </td>
        </tr>
        <tr>
            <td class='tbl2'>Themes per Page:</td>
            <td class='tbl2'><input name='themes_per_page' class='textbox' type='text' maxlength='2' value='".$themedb_settings["items_per_page"]."' style='width:25px;vertical-align:middle;' /></td>
        </tr>
        <tr>
            <td class='tbl2'>Downloads:</td>
            <td class='tbl2'>Max Filesize:<input name='max_file_size' class='textbox' style='width:60px;vertical-align:middle;' type='text' value='".$themedb_settings["max_file_size"]."' />Bytes<br />
            </td>
        </tr>
        <tr>
            <td class='tbl2'>Screenshots:</td>
            <td class='tbl2'>Max Filesize:<input name='max_screen_size' class='textbox' style='width:60px;vertical-align:middle;' type='text' value='".$themedb_settings["max_screen_size"]."' />Bytes<br />
            Max Width: <input name='screen_w' class='textbox' style='width:25px;vertical-align:middle;' type='text' value='".$themedb_settings["screen_w"]."' />px<br />
            Max Height: <input name='screen_h' class='textbox' style='width:25px;vertical-align:middle;' type='text' value='".$themedb_settings["screen_h"]."' />px</td>
        </tr>
        <tr>
            <td class='tbl2'>Thumbnails:</td>
            <td class='tbl2'>Max Filesize:<input name='max_thumb_size' class='textbox' style='width:60px;vertical-align:middle;' type='text' value='".$themedb_settings["max_thumb_size"]."' />Bytes<br />
            Max Width: <input name='thumb_w' class='textbox' style='width:25px;vertical-align:middle;' type='text' value='".$themedb_settings["thumb_w"]."' />px<br />
            Max Height: <input name='thumb_h' class='textbox' style='width:25px;vertical-align:middle;' type='text' value='".$themedb_settings["thumb_h"]."' />px</td>
        </tr>
        <tr><td class='tbl2' colspan='2' style='text-align:center;'><input type='submit' name='submit_settings' value='Change Settings' class='button' /></td></tr>";

        close_cat_table();
        echo "</form>";
    }
    //
    
    open_cat_table();
    echo "<tr><th colspan='5' class='forum-caption' style='text-align:left;'>Awards</th></tr>";
    echo "<tr><th class='tbl2'>Name</th><th class='tbl1'>Image</th><th class='tbl2'>Action</th></tr>";
    
    $award_res = dbquery("SELECT * FROM ".THEME_DB_AWARDS);
    
    if(dbrows($award_res)){
	    while($data = dbarray($award_res)){
	    	if($action == "edit_award" && isset($_GET['award_id']) && $_GET['award_id'] == $data['award_id']){
				echo "<tr><td class='tbl2' style='font-weight:bold;'>New Award:</td>
		            <td class='tbl2' colspan='2'>
		            <form style='display:inline;' method='post' action='".FUSION_SELF.$aidlink."&amp;action=edit_award&amp;award_id=".$data['award_id']."'>
		                <label for='award_name' style='display: block; width: 100px; height: 2em; line-height: 2em;  float: left;'>Name:</label>
						<input style='vertical-align: middle; width:200px;' type='text' class='textbox' name='award_name' value='".stripslash($data['award_name'])."' />
						<label for='award_image'>Image:</label>
						<input style='vertical-align: middle; width: 200px;' type='text' class='textbox' name='award_image' value='".stripslash($data['award_image'])."' /><br style='clear:both;'/>
		                <label for='award_desc' style='display: block; width: 100px; height: 2em; line-height: 2em;  float: left;'>Description:</label>
						<textarea style='width:50%;height:25px;vertical-align: middle;' class='textbox' name='award_desc'>".stripslash($data['award_desc'])."</textarea><br style='clear:both;'/>
		                <label for='award_req' style='display: block; width: 100px; height: 2em; line-height: 2em; float: left;'>Requirements:</label>
						<textarea style='width:50%;height:25px;vertical-align: middle;' class='textbox' name='award_req'>".stripslash($data['award_req'])."</textarea>
						<br/>
		                <input class='button' type='submit' name='edit_award_submit' value='Submit Changes!' />
		            </form>
		            </td>
		        </tr>";
			}else{
				echo "<tr><td class='tbl1'>".$data['award_name']."</td><td class='tbl1'><img src='".$data['award_image']."' alt='".$data['award_name']."'/></td>
				<td class='tbl1'>
					<a href='".FUSION_SELF.$aidlink."&amp;action=edit_award&amp;award_id=".$data['award_id']."'>Edit</a> |
	                <a href='".FUSION_SELF.$aidlink."&amp;action=delete_award&amp;award_id=".$data['award_id']."' onclick='return confirm(\"Really Delete ".$data['award_name']."\")'>Delete</a>
				</td></tr>";
			}
		}
	}else{
		echo "<tr><td colspan='3' class='tbl1' style='text-align: center;'>No Awards defined</td></tr>";
	}
	
	if($action != "edit_award"){
        echo "<tr><td class='tbl2' style='font-weight:bold;'>New Award:</td>
            <td class='tbl2' colspan='2'>
            <form style='display:inline;' method='post' action='".FUSION_SELF.$aidlink."&amp;action=new_award'>
                <label for='award_name' style='display: block; width: 100px; height: 2em; line-height: 2em;  float: left;'>Name:</label><input style='vertical-align: middle; width:200px;' type='text' class='textbox' name='award_name' />
				<label for='award_image'>Image:</label><input style='vertical-align: middle; width: 200px;' type='text' class='textbox' name='award_image' /><br style='clear:both;'/>
                <label for='award_desc' style='display: block; width: 100px; height: 2em; line-height: 2em;  float: left;'>Description:</label><textarea style='width:50%;height:25px;vertical-align: middle;' class='textbox' name='award_desc'></textarea><br style='clear:both;'/>
                <label for='award_req' style='display: block; width: 100px; height: 2em; line-height: 2em; float: left;'>Requirements:</label><textarea style='width:50%;height:25px;vertical-align: middle;' class='textbox' name='award_req'></textarea>
                <input class='button' type='submit' name='new_award_submit' value='Create!' />
            </form>
            </td>
        </tr>";
    }else{
        echo"<tr><td class='tbl2' colspan='3'><a href='".FUSION_SELF.$aidlink."'>New Award</a></td></tr>";
    }
    
    close_cat_table();
    
    //Awards
closetable();

require_once THEMES."templates/footer.php";
?>
