<?php
if (!defined("IN_FUSION")) die("Access Denied");

require_once INCLUDES."photo_functions_include.php";
include_once INCLUDES."bbcode_include.php";

function rm_recurse($file) {
    if (is_dir($file) && !is_link($file)) {
        foreach(glob($file.'/*') as $sf) {
            if ( !rm_recurse($sf) ) {
                error_log("Failed to remove $sf\n");
                return false;
            }
        }
        return rmdir($file);
    } else {
        return unlink($file);
    }
}

/*
function check_zip_structure($file){
    return true;
    $zip = new ZipArchive;
    $errors = "";
    $worked = $zip->open($file);
    if($worked === true){
	    $tmp_dir = THEME_DB_DIR."temp/".md5($file)."/";
	    if(is_dir($tmp_dir)){
		    rm_recurse($tmp_dir);
	    }
	    mkdir($tmp_dir, 0777);
	    $zip->extractTo($tmp_dir);
	    
	    if(!file_exists($tmp_dir."readme.txt") && !file_exists($tmp_dir."readme.html") && !file_exists($tmp_dir."readme.htm")){
		    $errors .= "The archive must contain a readme (txt, htm or html) <br />";
	    }
	    if(!is_dir($tmp_dir."themes")){
		    $errors .= "The archive must contain a themes folder with another folder containing the theme. Take a look at the image depicting the folder structure in the Submission Guidelines.";
	    }
	    
	    rm_recurse($tmp_dir);
	    
	    if(!empty($errors)){
		    return $errors;
	    }else{
		    return true;
	    }
    }else{
	    return "Could not open Zip File";
    }
}*/

function check_zip_structure($file){
	$tmp_dir = THEME_DB_DIR."temp/".md5($file)."/";
	if(is_dir($tmp_dir)){
		rm_recurse($tmp_dir);
	}
	$errors = "";
	if(mkdir($tmp_dir, 0777)){
		if(shell_exec("unzip $file -d $tmp_dir")){
			if(!file_exists($tmp_dir."readme.txt") &&
			!file_exists($tmp_dir."readme.html") &&
			!file_exists($tmp_dir."readme.htm") &&
			!file_exists($tmp_dir."install.txt") &&
			!file_exists($tmp_dir."install.htm") &&
			!file_exists($tmp_dir."install.html")
			){
				$errors .= "The archive must contain a readme(.txt, .htm or .html) or install(.txt, .htm or .html) <br />";
			}
			if(!is_dir($tmp_dir."themes")){
				$errors .= "The archive must contain a themes folder with another folder containing the theme. Take a look at the image depicting the folder structure in the Submission Guidelines.<br />";
			}
			//Mod by Sveinung
  /*    if(!file_exists($tmp_dir."agpl.txt") &&
			!file_exists($tmp_dir."AGPL.txt") &&
			!file_exists($tmp_dir."gpl.txt") &&
			!file_exists($tmp_dir."GPL.txt") &&
			!file_exists($tmp_dir."licence.txt")
			){
				$errors .= "The archive must contain a licence (agpl.txt, AGPL.txt, gpl.txt, GPL.txt OR license.txt)<br />";
			//End mod
      } */
			if(file_exists($tmp_dir."Thumbs.db") ||
			file_exists($tmp_dir."themes/Thumbs.db") ||
			file_exists($tmp_dir."extras/Thumbs.db")){
				$errors .= "Please remove the Thumbs.db files from the archive. These are unnecessary Windows XP System related files. They might be <a href='http://www.microsoft.com/windowsxp/using/helpandsupport/learnmore/tips/hiddenfiles.mspx' target='_blank'>hidden</a>.<br />";
			}
			rm_recurse($tmp_dir);
		}else{
			$errors .= "Extracting the theme archive failed. Contact <a href='".BASEDIR."profile.php?lookup=20'>Sveinungs</a> if the error persists after checking the validity of the zip file.<br />";
		}
	}else{
		$errors .= "Creating the temporary zip folder failed. Contact <a href='".BASEDIR."profile.php?lookup=20'>Sveinungs</a>.<br />";
	}
	
	if(!empty($errors)){
		return $errors;
	}else{
		return true;
	}
}


function check_submission($action="new", $theme_id="", $mode="user"){

    global $themedb_settings, $locale, $userdata;
    if($action == "edit")
        $theme_data = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."themedb WHERE id='".$theme_id."'"));
    $errors = "";
    if(isset($_POST['submit_theme'])){
      //Check submitted Data
        //Name
        if(!preg_match("/^[\s-0-9A-Z_\[\]]+$/i", $_POST['theme_name']))
            $errors .= $locale['themedb_theme']." ".$locale['themedb_theme_name']." ".$locale['themedb_invalid_chars']."<br />";
        if(empty($_POST['theme_name']))
            $errors .= $locale['themedb_theme']." ".$locale['themedb_theme_name']." ".$locale['themedb_is_empty']."<br />";
        //Category
        if(dbrows(dbquery("SELECT cat_id FROM ".DB_PREFIX."themedb_cats WHERE cat_id = '".intval($_POST['theme_cat_id'])."'")) != 1)
            $errors .= $locale['themedb_category']." ".$locale['themedb_not_found']."<br />";
        //Fusion Version
        if(!in_array($_POST['theme_fusion_version'], explode("|", $themedb_settings["fusion_versions"])))
            $errors .= $locale['themedb_fusion']." ".$locale['themedb_version']." ".$locale['themedb_not_found']."<br />";
        //Description
        if(empty($_POST['theme_desc']))
            $errors .= $locale['themedb_desc']." ".$locale['themedb_is_empty']."<br />";
        //CSS Validity
        if(isset($_POST['theme_valid_css']) AND !in_array($_POST['theme_valid_css'], array(1,0)))
            $errors .= "CSS ".$locale['themedb_validity']." ".$locale['themedb_invalid_value']."<br />";
        //HTML Validity
        if(isset($_POST['theme_valid_html']) AND !in_array($_POST['theme_valid_html'], array(1,0)))
            $errors .= "HTML ".$locale['themedb_validity']." ".$locale['themedb_invalid_value']."<br />";
        //Brightness
        if(!in_array($_POST['theme_brightness'], array(0,1,2,3,4)))
            $errors .= $locale['themedb_brightness']." ".$locale['themedb_invalid_value']."<br />";
        //Graphic Amount
        if(!in_array($_POST['theme_graphic_amnt'], array(0,1,2,3)))
            $errors .= $locale['themedb_graphic_amnt']." ".$locale['themedb_invalid_value']."<br />";
        //Copyright
        if(empty($_POST['theme_copyright']))
            $errors .= $locale['themedb_copyright']." ".$locale['themedb_is_empty']."<br />";
        //Width
        if(empty($_POST['theme_width']))
            $errors .= $locale['themedb_width']." ".$locale['themedb_is_empty']."<br />";
        elseif(!is_numeric($_POST['theme_width']) OR $_POST['theme_width'] > 1600)
            $errors .= $locale['themedb_width']." ".$locale['themedb_invalid_value']."<br />";
        //Version
        if(empty($_POST['theme_version']))
            $errors .= $locale['themedb_version']." ".$locale['themedb_is_empty']."<br />";
        elseif(!is_numeric($_POST['theme_version']) OR $_POST['theme_version'] > 1600)
            $errors .= $locale['themedb_version']." ".$locale['themedb_invalid_value']."<br />";
        //Colors
        if(empty($_POST['theme_colors']))
            $errors .= $locale['themedb_main_color']." ".$locale['themedb_is_empty']."<br />";
        //Theme Author
        if(!empty($_POST['theme_user_type']) AND $_POST['theme_user_type'] == "me"){
            if(dbrows(dbquery("SELECT * FROM ".DB_PREFIX."users WHERE user_id = ".$userdata['user_id'])) != 1)
                $errors .= $locale['themedb_user']." ".$locale['themedb_not_found']."<br />";
        }elseif(!empty($_POST['theme_user_type']) AND $_POST['theme_user_type'] == "else"){
            if(empty($_POST['author_name_else']))
                $errors .= $locale['themedb_author']." ".$locale['themedb_is_empty']."<br />";
            if(empty($_POST['author_mail_else']))
                $errors .= $locale['themedb_author']." ".$locale['themedb_author_mail']." ".$locale['themedb_is_empty']."<br />";
            elseif(!preg_match("/^[-0-9A-Z_\.]{1,50}@([-0-9A-Z_\.]+\.){1,50}([0-9A-Z]){2,4}$/i", $_POST['author_mail_else']))
                $errors .= $locale['themedb_author']." ".$locale['themedb_author_mail']." ".$locale['themedb_invalid_chars']."<br />";
        }elseif(!empty($_POST['theme_user_type']) AND $_POST['theme_user_type'] == "user"){
            if(dbrows(dbquery("SELECT * FROM ".DB_PREFIX."users WHERE user_id = ".$_POST['author_id_user'])) != 1)
                $errors .= $locale['themedb_user']." ".$locale['themedb_not_found']."<br />";
        }elseif(!empty($_POST['theme_user_type']) AND $_POST['theme_user_type'] == "submitter"){
            if(is_numeric($_POST['author_id_submitter'])){
                if(dbrows(dbquery("SELECT * FROM ".DB_PREFIX."themedb WHERE author_id = ".$_POST['author_id_submitter'])) < 1)
                    $errors .= $locale['themedb_user']." ".$locale['themedb_not_found']."<br />";
            }else{
                if(dbrows(dbquery("SELECT * FROM ".DB_PREFIX."themedb WHERE author_name = '".$_POST['author_id_submitter']."'")) < 1)
                    $errors .= $locale['themedb_user']." ".$locale['themedb_not_found']."<br />";
            }
        }
        if($action == "edit" AND $mode == "admin")
            if(empty($_POST['author_id']) AND empty($_POST['author_name']))
                $errors .= $locale['themedb_user']." ID/".$locale['themedb_theme_name']." ".$locale['themedb_is_empty']."<br />";
        //Files
        if($action == "edit"){
            $theme_file = THEME_DB_DIR."downloads/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."].zip";
            $screen_file = THEME_DB_DIR."screenshots/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."].".$theme_data['screenshot_ext'];
        }
        //Theme Archive File
        if($action == "new" OR ($action == "edit" AND (isset($_FILES['theme_file']) OR !file_exists($theme_file)))){
            if($_FILES['theme_file']['size'] <= 512)
                $errors .= $locale['themedb_theme']." ".$locale['themedb_file']." ".$locale['themedb_broken']."<br />";
            elseif($_FILES['theme_file']['size'] > $themedb_settings['max_file_size'])
                $errors .= $locale['themedb_theme']." ".$locale['themedb_file']." ".$locale['themedb_too_large']."<br />";
            /*elseif(!in_array($_FILES['theme_file']['type'], array("application/zip", "application/x-zip", "application/x-zip-compressed")))
                $errors .= $locale['themedb_theme']." ".$locale['themedb_file']." ".$locale['themedb_not_zip'].". It is ".$_FILES['theme_file']['type']." now<br />";*/
            elseif(check_zip_structure($_FILES['theme_file']['tmp_name']) !== true){
				$errors .= check_zip_structure($_FILES['theme_file']['tmp_name']); 
			}
        }
        //Theme Screenshot File
        if($action == "new" OR ($action == "edit" AND (isset($_FILES['screenshot_file']) OR !file_exists($screen_file)))){
            $screenshot_info = getimagesize($_FILES['screenshot_file']['tmp_name']);
            if($_FILES['screenshot_file']['size'] <= 1024)
                $errors .= $locale['themedb_screenshot']." ".$locale['themedb_file']." ".$locale['themedb_broken']."<br />";
            elseif($_FILES['screenshot_file']['size'] > $themedb_settings['max_screen_size'])
                $errors .= $locale['themedb_screenshot']." ".$locale['themedb_file']." ".$locale['themedb_too_large']."<br />";
            elseif(!in_array($screenshot_info[2], array(1,2,3)))
                $errors .= $locale['themedb_screenshot']." ".$locale['themedb_file']." ".$locale['themedb_not_image']."<br />";
            elseif($screenshot_info[0] > $themedb_settings['screen_w'] OR $screenshot_info[1] > $themedb_settings['screen_h'] )
                $errors .= $locale['themedb_screenshot']." ".$locale['themedb_too_large']."<br />";
        }
        //Errors?
        if(!empty($errors)){
            display_message($locale['themedb_errors_occured'],$errors);
            return false;
        }else
            return true;
    }else
        return false;
}



function write_submission($mode="user",$action="new",$theme_id=""){
    global $userdata,$locale;
    $error = 0;
    //Old Theme Data
    if($action == "edit"){
        $theme_result = dbquery("SELECT * FROM ".DB_PREFIX."themedb WHERE id=".$theme_id);
        if(!$theme_result){
            display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["theme_query_error"]);
            return false;
        }else
            $theme_data = dbarray($theme_result);
    }else
        $theme_data = "";
    //Collect Data for DB INSERT/UPDATE
    $name = addslash(descript($_POST['theme_name']));
    $cat_id = intval($_POST['theme_cat_id']);
    $folder = !isset($_POST['theme_folder']) ? "" : addslash(descript($_POST['theme_folder']));
    $version = addslash(descript($_POST['theme_version']));
    $fusion_version = addslash(descript($_POST['theme_fusion_version']));
    $desc = addslash(descript($_POST['theme_desc']));
    $width_type = (intval($_POST['theme_width']) > 100 ? 1 : 0);
    $width = intval($_POST['theme_width']);
    $main_colors = addslash(descript($_POST['theme_colors']));
    $valid_css = isset($_POST['theme_valid_css']) ? 1 : 0;
    $valid_html = isset($_POST['theme_valid_html']) ? 1 : 0;
    $brightness = intval($_POST['theme_brightness']);
    $graphic_amnt = intval($_POST['theme_graphic_amnt']);
    $blank_button = isset($_POST['theme_blank_button']) ? 1 : 0;
    $blank_logo = isset($_POST['theme_blank_logo']) ? 1 : 0;
    $approved = ($mode == "admin" AND $action == "edit") ? $theme_data['approved'] : 0;
    $dl_count = $action == "edit" ? $theme_data['download_count'] : 0;
    $view_count = $action == "edit" ? $theme_data['view_count'] : 0;
    $recommended = $action == "edit" ? $theme_data['recommended'] : 0;
    $copyright = addslash(descript($_POST['theme_copyright']));
    if($mode != "admin"){
        if($_POST['theme_user_type'] == "me"){
            $author_id = $userdata['user_id'];
            $author_name = "";
            $author_web = "";
            $author_mail = "";
        }elseif($_POST['theme_user_type'] == "user"){
            $author_id = intval($_POST['author_id_user']);
            $author_name = "";
            $author_web = "";
            $author_mail = "";
        }elseif($_POST['theme_user_type'] == "submitter"){
            if(is_numeric($_POST['author_id_submitter'])){
                $author_id = intval($_POST['author_id_submitter']);
                $author_name = "";
                $author_web = "";
                $author_mail = "";
            }else{
                $author_data = dbarray(dbquery("SELECT author_name, author_web,author_mail FROM ".DB_PREFIX."themedb WHERE author_name = '".intval($_POST['author_id_submitter'])."' GROUP BY author_name"));
                $author_id = "";
                $author_name = addslash(descript($_POST['author_id_submitter']));
                $author_web = $author_data['author_web'];
                $author_mail = $author_data['author_mail'];
            }
        }elseif($_POST['theme_user_type'] == "else"){
            $author_id = "";
            $author_name = addslash(descript($_POST['author_name_else']));
            $author_web = addslash(descript($_POST['author_web_else']));
            $author_mail = addslash(descript($_POST['author_mail_else']));
        }
    }else{
        $author_id = intval($_POST['author_id']);
        $author_name = addslash(descript($_POST['author_name']));
        $author_mail = addslash(descript($_POST['author_mail']));
        $author_web = addslash(descript($_POST['author_web']));
    }
    $submitter_id = $userdata['user_id'];
    if($action != "edit" OR ($action == "edit" AND !empty($_FILES['screenshot_file']))){
        $screen_data = getimagesize($_FILES['screenshot_file']['tmp_name']);
        if($screen_data[2] == 2)
            $screen_ext = "jpg";
        elseif($screen_data[2] == 3)
            $screen_ext = "png";
        elseif($screen_data[2] == 1)
            $screen_ext = "gif";
    }else
        $screen_ext = $theme_data['screenshot_ext'];
    if($action != "edit" OR ($action == "edit" AND !empty($_FILES['theme_file'])))
        $byte_size = $_FILES['theme_file']['size'];
    else
        $byte_size = $theme_data['size'];
    //INSERT
    if($action == "new"){
        $result = dbquery("INSERT INTO
        ".DB_PREFIX."themedb SET
        name='".$name."',
        theme_folder='".$folder."',
        cat_id='".$cat_id."',
        submission_time='".time()."',
        last_change_time='".time()."',
        author_id='".$author_id."',
        author_name='".$author_name."',
        author_web='".$author_web."',
        author_mail='".$author_mail."',
        submitter_id = '".$submitter_id."',
        `desc`='".$desc."',
        copyright='".$copyright."',
        graphic_amnt='".$graphic_amnt."',
        valid_css='".$valid_css."',
        valid_html='".$valid_html."',
        brightness='".$brightness."',
        color='".$main_colors."',
        blank_button='".$blank_button."',
        blank_logo='".$blank_logo."',
        size='".$byte_size."',
        width_type='".$width_type."',
        width='".$width."',
        version='".$version."',
        fusion_version='".$fusion_version."',
        approved='".$approved."',
        recommended='".$recommended."',
        download_count='".$dl_count."',
        view_count='".$view_count."',
        screenshot_ext='".$screen_ext."'");
        if(!$result){
            display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["mysql_new_error"]);
            return false;
        }
    //Update
    }elseif($action == "edit"){
        $result = dbquery("UPDATE
        ".DB_PREFIX."themedb SET
        name='".$name."',
        theme_folder='".$folder."',
        cat_id='".$cat_id."',
        last_change_time='".time()."',
        author_id='".$author_id."',
        author_name='".$author_name."',
        author_web='".$author_web."',
        author_mail='".$author_mail."',
        `desc`='".$desc."',
        copyright='".$copyright."',
        graphic_amnt='".$graphic_amnt."',
        valid_css='".$valid_css."',
        valid_html='".$valid_html."',
        brightness='".$brightness."',
        color='".$main_colors."',
        blank_button='".$blank_button."',
        blank_logo='".$blank_logo."',
        size='".$byte_size."',
        width_type='".$width_type."',
        width='".$width."',
        version='".$version."',
        fusion_version='".$fusion_version."',
        approved='".$approved."',
        recommended='".$recommended."',
        download_count='".$dl_count."',
        view_count='".$view_count."',
        screenshot_ext='".$screen_ext."'
        WHERE id ='".$theme_data['id']."'");
        if(!$result){
            display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["mysql_edit_error"]);
            return false;
        }
    }
    $theme_id = $action == "new" ? mysql_insert_id() : $theme_data['id'];
    $theme_file = empty($_FILES['theme_file']) ? "" : $_FILES['theme_file'];
    $screen_file = empty($_FILES['screenshot_file']) ? "" : $_FILES['screenshot_file'];
    if(handle_theme_files($action, $theme_data, $theme_file,$screen_file, $name, $theme_id, $cat_id)){
        if($action == "new")
            submission_notification($userdata['user_name'], $userdata['user_email']);
        return true;
    }else
        return false;
}

function handle_theme_files($action="new", $theme_data="", $theme, $screenshot, $theme_name, $theme_id, $cat_id){
    global $themedb_settings, $locale;
    if($action == "edit"){
        $theme_source_old = THEME_DB_DIR."downloads/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."].zip";
        $theme_source = empty($theme) ? $theme_source_old : $theme['tmp_name'];
        $theme_target = THEME_DB_DIR."downloads/".$cat_id."/".$theme_name."[".$theme_id."].zip";
        
        
        if(!empty($theme)){
        	@chmod($theme_target, 0777);
			@unlink($theme_target);
            if(!copy($theme_source,$theme_target)){
                display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["theme_update_failed"]);
                return false;
            }else
                display_message($locale['themedb_msg_success'],$locale['themedb_submissions']["theme_update_ok"]);
        }else{
            if(!file_exists($theme_target)){
                if(!file_exists($theme_source_old)){
                    display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["theme_file_missing"]);
                    return false;
                }else{
                	@chmod($theme_source_old, 0777);
                    if(!rename($theme_source_old, $theme_target)){
                        display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["theme_move_failed"]);
                        return false;
                    }else
                        display_message($locale['themedb_msg_success'],$locale['themedb_submissions']["theme_move_ok"]);
                }
            }
        }
        if(!empty($screenshot)){
            $screen_data = getimagesize($screenshot['tmp_name']);
            if($screen_data[2] == 2)
                $screen_ext = "jpg";
            elseif($screen_data[2] == 3)
                $screen_ext = "png";
            elseif($screen_data[2] == 1)
                $screen_ext = "gif";
            else{
                display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["imagetype_error"]);
                return false;
            }
            $thumb_width = $themedb_settings['thumb_w'];
            $thumb_height = ($screen_data[0]/$screen_data[1])*$thumb_width;
            $screen_source = $screenshot['tmp_name'];
            $screen_source_old = dirname($_SERVER['SCRIPT_FILENAME'])."/screenshots/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."].".$theme_data['screenshot_ext'];
            $thumb_source_old = THEME_DB_DIR."screenshots/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."]t.".$theme_data['screenshot_ext'];
            $screen_target = THEME_DB_DIR."screenshots/".$cat_id."/".$theme_name."[".$theme_id."].".$screen_ext;
            $thumb_target = THEME_DB_DIR."screenshots/".$cat_id."/".$theme_name."[".$theme_id."]t.".$screen_ext;
            
            @chmod($screen_target, 0777);
            @unlink($screen_target);
            if(!copy($screen_source,$screen_target)){
                display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["screen_update_failed"]);
                return false;
            }else{
            	@chmod($thumb_target, 0777);
            	@unlink($thumb_target);
                createthumbnail($screen_data[2],$screen_source,$thumb_target,$thumb_width,$thumb_height);
                display_message($locale['themedb_msg_success'],$locale['themedb_submissions']["screen_update_ok"]);
            }
        }else{
            $screen_source_old = THEME_DB_DIR."screenshots/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."].".$theme_data['screenshot_ext'];
            $thumb_source_old = THEME_DB_DIR."screenshots/".$theme_data['cat_id']."/".$theme_data['name']."[".$theme_data['id']."]t.".$theme_data['screenshot_ext'];
            $screen_target = THEME_DB_DIR."screenshots/".$cat_id."/".$theme_name."[".$theme_id."].".$theme_data['screenshot_ext'];
            $thumb_target = THEME_DB_DIR."screenshots/".$cat_id."/".$theme_name."[".$theme_id."]t.".$theme_data['screenshot_ext'];
            
            if(!file_exists($screen_target) AND !file_exists($thumb_target)){
                if(!file_exists($screen_source_old)){
                    display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["screen_file_missing"]);
                    return false;
                }else{
                	@chmod($screen_source_old, 0777);
                    if(!rename($screen_source_old, $screen_target) OR !rename($thumb_source_old, $thumb_target)){
                        display_message($locale['themedb_msg_error'],$locale['themedb_submissions']["screen_move_failed"]);
                        return false;
                    }else
                        display_message($locale['themedb_msg_success'],$locale['themedb_submissions']["screen_move_ok"]);
                }
            }
        }
    }else{
        if(empty($theme)){
            display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["theme_file_missing"]);
            return false;
        }
        $theme_source = $theme['tmp_name'];
        $theme_target = THEME_DB_DIR."downloads/".$cat_id."/".$theme_name."[".$theme_id."].zip";

        $screen_data = getimagesize($screenshot['tmp_name']);
        if($screen_data[2] == 2)
            $screen_ext = "jpg";
        elseif($screen_data[2] == 3)
            $screen_ext = "png";
        elseif($screen_data[2] == 1)
            $screen_ext = "gif";
        else{
            display_message($locale['themedb_msg_error'], $locale['themedb_submissions']["imagetype_error"]);
            return false;
        }
        $screen_source = $screenshot['tmp_name'];
        $screen_target = THEME_DB_DIR."screenshots/".$cat_id."/".$theme_name."[".$theme_id."].".$screen_ext;
        $thumb_target = THEME_DB_DIR."screenshots/".$cat_id."/".$theme_name."[".$theme_id."]t.".$screen_ext;
        $thumb_width = $themedb_settings['thumb_w'];
        $thumb_height = ($screen_data[0]/$screen_data[1])*$thumb_width;
        if(!copy($theme_source,$theme_target)){
            return false;
        }
        if(!copy($screen_source,$screen_target)){
            return false;
        }
        createthumbnail($screen_data[2],$screen_source,$thumb_target,$thumb_width,$thumb_height);
    }
    return true;
}

function submission_notification($name, $email){
    global $settings, $locale, $executed;
    if(isset($executed) AND $executed == 1){
        return false;
    }else{
        sendemail($name,$email,$settings['siteusername'],$settings['siteemail'],$locale['themedb_submit_mail_title'], $locale['themedb_submit_mail']);
        sendemail($settings['siteusername'],$settings['siteemail'],$settings['siteusername'],$settings['siteemail'],"New Submission","New Submission for review");
        return true;
    }
}


//Theme Form for Submissions, User and Admin Edit
function theme_form($mode="user", $action="new", $data=""){

    global $themedb_settings, $locale, $userdata, $aidlink;
    
    if($action == "edit"){
    $theme_file = THEME_DB_DIR."downloads/".$data['cat_id']."/".$data['name']."[".$data['id']."].zip";
    $screen_file = THEME_DB_DIR."screenshots/".$data['cat_id']."/".$data['name']."[".$data['id']."].".$data['screenshot_ext'];
    $thumb_file = THEME_DB_DIR."screenshots/".$data['cat_id']."/".$data['name']."[".$data['id']."]t.".$data['screenshot_ext'];
    if(!empty($_GET['delete_file']) AND $_GET['delete_file'] == 1 AND (iADMIN OR $userdata['user_id'] == $data['author_id']))
        if(unlink($theme_file))
            display_message("Theme File deleted", "The Theme File has succesfully been deleted.");
        else
            display_message("Theme File Delete failed", "The Theme File could not be deleted.");
    if(!empty($_GET['delete_screen']) AND $_GET['delete_screen'] == 1 AND (iADMIN OR $userdata['user_id'] == $data['author_id']))
        if(unlink($screen_file) AND unlink($thumb_file))
            display_message("Screenshot Files deleted", "The Screenshot Files have succesfully been deleted.");
        else
            display_message("Screenshot Files Delete failed", "The Screenshot Files could not be deleted.");
    }


    if($action == "new"){
        $theme_name = !isset($_POST['theme_name']) ? "" : $_POST['theme_name'];
        $theme_version = !isset($_POST['theme_version']) ? "" : $_POST['theme_version'];
        $theme_desc = !isset($_POST['theme_desc']) ? "" : $_POST['theme_desc'];
        $theme_cat= !isset($_POST['theme_cat_id']) ? "" : $_POST['theme_cat_id'];
        $theme_width = !isset($_POST['theme_width']) ? "" : $_POST['theme_width'];
        $theme_folder = !isset($_POST['theme_folder']) ? "" : $_POST['theme_folder'];
        $graphic_amnt = !isset($_POST['theme_graphic_amnt']) ? "" : $_POST['theme_graphic_amnt'];
        $theme_colors = !isset($_POST['theme_colors']) ? "" : $_POST['theme_colors'];
        $brightness = !isset($_POST['theme_brightness']) ? "" : $_POST['theme_brightness'];
        $fusion_version = !isset($_POST['theme_fusion_version']) ? "" : $_POST['theme_fusion_version'];
        $valid_css = !isset($_POST['theme_valid_css']) ? "" : $_POST['theme_valid_css'];
        $valid_html = !isset($_POST['theme_valid_html']) ? "" : $_POST['theme_valid_html'];
        $blank_logo = !isset($_POST['theme_blank_logo']) ? "" : $_POST['theme_blank_logo'];
        $blank_button = !isset($_POST['theme_blank_button']) ? "" : $_POST['theme_blank_button'];
        $author_name_else = !isset($_POST['author_name_else']) ? "" : $_POST['author_name_else'];
        $author_mail_else = !isset($_POST['author_mail_else']) ? "" : $_POST['author_mail_else'];
        $author_web_else = !isset($_POST['author_web_else']) ? "" : $_POST['author_web_else'];
        $user_type = !isset($_POST['theme_user_type']) ? "" : $_POST['theme_user_type'];
        $author_id_user = !isset($_POST['author_id_user']) ? "" : $_POST['author_id_user'];
        $author_id_submitter = !isset($_POST['author_id_submitter']) ? "" : $_POST['author_id_submitter'];
        $copyright = !isset($_POST['theme_copyright']) ? "" : $_POST['theme_copyright'];
        if($mode == "admin"){
            $author_id = !isset($_POST['author_id']) ? "" : $_POST['author_id'];
            $author_name = !isset($_POST['author_name'])? "" : $_POST['author_name'];
            $author_mail = !isset($_POST['author_mail']) ? "" : $_POST['author_mail'];
            $author_web = !isset($_POST['author_web']) ? "" : $_POST['author_web'];
        }
    }elseif($action == 'edit'){
        if(empty($data)){
            display_message("Error!", "No Data for Edit");
        }else{
            $theme_name = !isset($_POST['theme_name']) ? stripinput(stripslash($data['name'])) : $_POST['theme_name'];
            $theme_version = !isset($_POST['theme_version']) ? stripinput(stripslash($data['version'])) : $_POST['theme_version'];
            $theme_desc = !isset($_POST['theme_desc']) ? stripinput(stripslash($data['desc'])) : $_POST['theme_desc'];
            $theme_cat= !isset($_POST['theme_cat_id']) ? $data['cat_id'] : $_POST['theme_cat_id'];
            $theme_width = !isset($_POST['theme_width']) ? $data['width'] : $_POST['theme_width'];
            $theme_folder = !isset($_POST['theme_folder']) ? stripinput(stripslash($data['theme_folder'])) : $_POST['theme_folder'];
            $graphic_amnt = !isset($_POST['theme_graphic_amnt']) ? $data['graphic_amnt'] : $_POST['theme_graphic_amnt'];
            $theme_colors = !isset($_POST['theme_colors']) ? stripinput(stripslash($data['color'])) : $_POST['theme_colors'];
            $brightness = !isset($_POST['theme_brightness']) ? $data['brightness'] : $_POST['theme_brightness'];
            $fusion_version = !isset($_POST['theme_fusion_version']) ? $data['fusion_version'] : $_POST['theme_fusion_version'];
            $valid_css = !isset($_POST['theme_valid_css']) ? $data['valid_css'] : $_POST['theme_valid_css'];
            $valid_html = !isset($_POST['theme_valid_html']) ? $data['valid_html'] : $_POST['theme_valid_html'];
            $blank_logo = !isset($_POST['theme_blank_logo']) ? $data['blank_logo'] : $_POST['theme_blank_logo'];
            $blank_button = !isset($_POST['theme_blank_button']) ? $data['blank_button'] : $_POST['theme_blank_button'];
			$copyright = !isset($_POST['theme_copyright']) ? stripinput(stripslash($data['copyright'])) : $_POST['theme_copyright'];
			if($mode != "admin"){
                $author_name_else = !isset($_POST['author_name_else']) ? stripinput(stripslash($data['author_name'])) : $_POST['author_name_else'];
                $author_mail_else = !isset($_POST['author_mail_else']) ? stripinput(stripslash($data['author_mail'])) : $_POST['author_mail_else'];
                $author_web_else = !isset($_POST['author_web_else']) ? stripinput(stripslash($data['author_web'])) : $_POST['author_web_else'];
                if(empty($_POST['theme_user_type'])){
                    if(!empty($data['author_id']) AND $data['author_id'] != $userdata['user_id']){
                        $res = dbquery("SELECT theme_id FROM ".DB_PREFIX."themedb WHERE author_id == ".$data['author_id']." AND theme_id !=".$data['id']);
                        if(dbrows($res) > 0)
                            $user_type = "submitter";
                        else
                            $user_type = "user";
                    }elseif($data['author_id'] == $userdata['user_id'])
                        $user_type = "me";
                    else
                        $user_type = "else";

                }else
                    $user_type = $_POST['theme_user_type'];
                $author_id_user = !isset($_POST['author_id_user']) ? $data['author_id'] : $_POST['author_id_user'];
                $author_id_submitter = !isset($_POST['author_id_submitter']) ? (is_numeric($data['author_id'])? $data['author_id'] : $data['author_name'] ) : $_POST['author_id_submitter'];
            }else{
                $author_id = !isset($_POST['author_id']) ? stripinput(stripslash($data['author_id'])) : $_POST['author_id'];
                $author_name = !isset($_POST['author_name']) ? stripinput(stripslash($data['author_name'])) : $_POST['author_name'];
                $author_mail = !isset($_POST['author_mail']) ? stripinput(stripslash($data['author_mail'])) : $_POST['author_mail'];
                $author_web = !isset($_POST['author_web']) ? stripinput(stripslash($data['author_web'])) : $_POST['author_web'];
            }

        }
    }
    

    #opentable($locale['themedb_name'].": ".($action == "new" ? $locale['themedb_submit'] : $locale['themedb_edit']));
    if($mode != "admin")
        echo"
        <script type='text/javascript'>
            function themedb_author(element){
                if(element.value == \"me\"){
                    document.getElementById(\"themedb_author_me\").style.display = \"block\";
                    document.getElementById(\"themedb_author_else\").style.display = \"none\";
                    document.getElementById(\"themedb_author_user\").style.display = \"none\";
                    document.getElementById(\"themedb_author_submitter\").style.display = \"none\";
                }else if(element.value == \"user\"){
                    document.getElementById(\"themedb_author_me\").style.display = \"none\";
                    document.getElementById(\"themedb_author_else\").style.display = \"none\";
                    document.getElementById(\"themedb_author_user\").style.display = \"block\";
                    document.getElementById(\"themedb_author_submitter\").style.display = \"none\";
                }else if(element.value == \"submitter\"){
                    document.getElementById(\"themedb_author_me\").style.display = \"none\";
                    document.getElementById(\"themedb_author_else\").style.display = \"none\";
                    document.getElementById(\"themedb_author_user\").style.display = \"none\";
                    document.getElementById(\"themedb_author_submitter\").style.display = \"block\";
                }else if(element.value == \"else\"){
                    document.getElementById(\"themedb_author_me\").style.display = \"none\";
                    document.getElementById(\"themedb_author_else\").style.display = \"block\";
                    document.getElementById(\"themedb_author_user\").style.display = \"none\";
                    document.getElementById(\"themedb_author_submitter\").style.display = \"none\";
                }
            }
        </script>";
    echo"
    <form enctype='multipart/form-data' name='themedb_submission' action='".($action == "new" ? FUSION_SELF : FUSION_REQUEST)."' method='post' style='line-height:18px; width:80%; margin:0 auto;'>
            <label style='float:left;vertical-align:middle;width:120px;' for='theme_name'>".$locale['themedb_theme']." ".$locale['themedb_theme_name'].":</label>
            <input class='textbox' name='theme_name' value='".$theme_name."' type='text' style='width:160px;' /><br style='clear:both;' />
            <label style='float:left;vertical-align:middle;width:120px;' for='theme_version'>".$locale['themedb_version'].":</label>
            <input class='textbox' name='theme_version' type='text' style='width:20px;' value='".$theme_version."' /><br style='clear:both;' />";
            if($mode == "admin")
            echo"
                <label style='float:left;vertical-align:middle;width:120px;' for='theme_folder'>".$locale['themedb_theme']." ".$locale['themedb_folder'].":</label>
                <select class='textbox' name='theme_folder' style='width:160px;'>
                    ".makefileopts(array_merge( array("None"),makefilelist(THEMES, ".|..", true, "folders")), $theme_folder)."
                </select><br style='clear:both;' />";
            echo"
            <label style='float:left;vertical-align:middle;width:120px;' for='theme_cat_id'>".$locale['themedb_category'].":</label>
            <select class='textbox' name='theme_cat_id' style='width:160px;'>";
                $cat_result = select_cats("","cat_name","asc");
                while($cat_data = dbarray($cat_result))
                    echo "<option value='".$cat_data["cat_id"]."' ".($theme_cat == $cat_data["cat_id"] ? "selected" : "").">".$cat_data["cat_name"]."</option>";
                echo"
            </select><br style='clear:both;' />
            <label style='float:left;vertical-align:middle;width:120px;' for='theme_fusion_version'>".$locale['themedb_display_fusion'].":</label>
            <select class='textbox' name='theme_fusion_version' style='width:160px;'>";
                $versions = explode("|", $themedb_settings["fusion_versions"]);
                foreach($versions as $version)
                    echo "<option value='".$version."' ".($fusion_version == $version ? "selected" : "").">".$version."</option>";
                echo"
            </select><br style='clear:both;' />
            <label style='float:left;vertical-align:middle;width:120px; height:240px;' for='theme_desc'>".$locale['themedb_desc'].":</label>
            <textarea class='textbox' name='theme_desc' id='theme_desc' style='width:70%; height:200px;'>".$theme_desc."</textarea><br />
			".display_bbcodes("padding-left: 100px;", "theme_desc", "themedb_submission")."
			
			
            <label style='float:left;vertical-align:middle;width:120px;' for='theme_colors'>".$locale['themedb_main_color'].":</label>
            <input class='textbox' name='theme_colors' value='".$theme_colors."' type='text' style='width:160px;' /><br style='clear:both;' />

            <label style='float:left;vertical-align:middle;width:120px;' for='theme_brightness'>".$locale['themedb_brightness'].":</label>
            <select name='theme_brightness' class='textbox'>";
                foreach($locale['themedb_brightness_value'] as $brightness_id => $brightness_value)
                    echo "<option value='".$brightness_id."' ".($brightness == $brightness_id ? "selected" : "").">".$brightness_value."</option>";
            echo "</select><br style='clear:both;' />

            <label style='float:left;vertical-align:middle;width:120px;' for='theme_graphic_amnt'>".$locale['themedb_graphic_amnt'].":</label>
            <select name='theme_graphic_amnt' class='textbox'>";
                foreach($locale['themedb_graphic_amnt_value'] as $graphic_amnt_id => $graphic_amnt_value)
                    echo "<option value='".$graphic_amnt_id."' ".($graphic_amnt == $graphic_amnt_id ? "selected" : "").">".$graphic_amnt_value."</option>";
            echo "</select><br style='clear:both;' />

            <label style='float:left;vertical-align:middle;width:120px;'>".$locale['themedb_validity'].":</label>
            <input type='checkbox' name='theme_valid_html' value='1' style='vertical-align:middle;' ".($valid_html == 1 ? "checked" : "")." />HTML <input type='checkbox' name='theme_valid_css' value='1' style='vertical-align:middle;' ".($valid_css == 1 ? "checked" : "")." />CSS<br style='clear:both;' />


             <label style='float:left;vertical-align:middle;width:120px;' for='theme_width'>".$locale['themedb_theme']." ".$locale['themedb_width'].":</label>
            <input class='textbox' name='theme_width' value='".$theme_width."' type='text' maxlength='3' style='width:3em;vertical-align:middle;' />in pixel or percent (".$locale['themedb_without_unit'].")<br style='clear:both;' />

            <label style='float:left;vertical-align:middle;width:120px;'>".$locale['themedb_blanks'].":</label>
            <input type='checkbox' value='1' style='vertical-align:middle;' name='theme_blank_logo' ".($blank_logo == 1 ? "checked" : "")." />".$locale['themedb_logo']." <input type='checkbox' value='1' style='vertical-align:middle;' name='theme_blank_button' ".($blank_button == 1 ? "checked" : "")." />".$locale['themedb_button']."<br style='clear:both;' />

            <label style='float:left;vertical-align:middle;width:120px;' for='theme_file'>".$locale['themedb_theme']." ".$locale['themedb_file'].":</label>
            ".(file_exists($theme_file) ? "<a href='".$theme_file."' target='_blank'>File</a> Exists. <a href='".FUSION_REQUEST."&amp;delete_file=1'>Click</a> to delete" : "<input class='textbox' name='theme_file' type='file' />")."
            <br style='clear:both;' />

            <label style='float:left;vertical-align:middle;width:120px;' for='screenshot_file'>".$locale['themedb_screenshot'].":</label>
            ".(file_exists($screen_file) ? "<a href='".$screen_file."' target='_blank'>File</a> Exists. <a href='".FUSION_REQUEST."&amp;delete_screen=1'>Click</a> to delete" : "<input class='textbox' name='screenshot_file' type='file' />")."
            <br style='clear:both;' />

            <label style='float:left;vertical-align:middle;width:120px;' for='author'>".$locale['themedb_author'].":</label>";
                if($mode != "admin"){
                    echo "
                    <div id='themedb_author' style='display:block;float:left;'>".$locale['themedb_author_who']."
                    <br />
                    <select class='textbox' name='theme_user_type' onchange='themedb_author(this);'>
                        <option value='me' ".($user_type == "me" ? "selected" : "").">".$locale['theme_db_user_types'][0]."</option>
                        <option value='user' ".($user_type == "user"? "selected" : "").">".$locale['theme_db_user_types'][2]."</option>
                        <option value='submitter' ".($user_type == "submitter"? "selected" : "").">".$locale['theme_db_user_types'][1]."</option>
                        <option value='else' ".($user_type == "else"? "selected" : "").">".$locale['theme_db_user_types'][3]."</option>
                    </select><br />
                    <div id='themedb_author_me'>
                        <label style='float:left;vertical-align:middle;width:70px;' for='author_name_me'>".$locale['themedb_author'].":</label>
                        ".$userdata['user_name']."
                        <br />
                        <label style='float:left;vertical-align:middle;width:70px;' for='author_web_me'>".$locale['themedb_author_web'].":</label>
                        ".$userdata['user_web']."
                        <br />
                        <label style='float:left;vertical-align:middle;width:70px;' for='author_mail_me'>".$locale['themedb_author_mail'].":</label>
                        ".$userdata['user_email']."
                        <br />
                    </div>
                    <div id='themedb_author_else'>
                        <label style='float:left;vertical-align:middle;width:70px;' for='author_name_else'>".$locale['themedb_author'].":</label>
                        <input class='textbox' type='text' name='author_name_else' value='".$author_name_else."' />
                        <br />
                        <label style='float:left;vertical-align:middle;width:70px;' for='author_web_else'>".$locale['themedb_author_web'].":</label>
                        <input class='textbox' type='text' name='author_web_else' value='".$author_web_else."' style='width:160px;' />
                        <br />
                        <label style='float:left;vertical-align:middle;width:70px;' for='author_mail_else'>".$locale['themedb_author_mail'].":</label>
                        <input class='textbox' type='text' name='author_mail_else' value='".$author_mail_else."' style='width:160px;' />
                        <br />
                    </div>
                    <div id='themedb_author_user'>
                        <label style='float:left;vertical-align:middle;width:90px;' for='author_id_user'>Select an User:</label>
                        <select class='textbox' name='author_id_user'>";
                            $author_result = dbquery("SELECT user_id,user_name FROM ".DB_PREFIX."users");
                        while($author_data = dbarray($author_result)){
                            echo "<option value='".$author_data['user_id']."' ".($author_id_user == $author_data['user_id'] ? "selected" : "").">".$author_data['user_name']."</option>\n";
                            }
                        echo "</select>
                    </div>
                    <div id='themedb_author_submitter'>
                        <label style='float:left;vertical-align:middle;width:90px;' for='author_id_submitter'>Select an User:</label>
                        <select class='textbox' name='author_id_submitter'>";
                            $author_result = dbquery("SELECT author_name, author_id, ".DB_PREFIX."users.user_name, CONCAT(author_id,author_name) as id FROM ".DB_PREFIX."themedb LEFT JOIN ".DB_PREFIX."users ON author_id = ".DB_PREFIX."users.user_id GROUP BY id");
                        while($author_data = dbarray($author_result)){
                            $author_value = !empty($author_data['author_id']) ? $author_data['author_id'] : $author_data['author_name'];
                            echo "<option value='".$author_value."' ".($author_id_submitter == $author_value ? "selected" : "").">".get_author($author_data['author_id'],$author_data['author_name'], false)."</option>\n";
                          }
                         